diff --git a/pgadmin/debugger/debugger.cpp b/pgadmin/debugger/debugger.cpp
index 445cd92..603a71a 100644
--- a/pgadmin/debugger/debugger.cpp
+++ b/pgadmin/debugger/debugger.cpp
@@ -14,15 +14,15 @@
 
 // App headers
 #include "pgAdmin3.h"
+#include "frm/frmMain.h"
 #include "debugger/debugger.h"
-#include "debugger/dbgBreakPoint.h"
-#include "debugger/ctlCodeWindow.h"
-#include "debugger/dlgDirectDbg.h"
-#include "debugger/frmDebugger.h"
+#include "debugger/dbgController.h"
 #include "schema/pgFunction.h"
 #include "schema/pgTrigger.h"
 #include "schema/edbPackageFunction.h"
 
+#include <stdexcept>
+
 ///////////////////////////////////////////////////
 // Debugger factory
 ///////////////////////////////////////////////////
@@ -42,7 +42,7 @@ wxWindow *debuggerFactory::StartDialog(frmMain *form, pgObject *obj)
 	if (res->GetVal(wxT("proname")).Contains(wxT(":")))
 	{
 		wxLogError(_("Functions with a colon in the name cannot be debugged."));
-		return 0;
+		return (wxWindow *)NULL;
 	}
 
 	if (res->GetLong(wxT("count")) != 1)
@@ -56,49 +56,20 @@ wxWindow *debuggerFactory::StartDialog(frmMain *form, pgObject *obj)
 			browser->DeleteChildren(coll->GetId());
 			coll->ShowTreeDetail(browser);
 		}
-		return 0;
+		return (wxWindow *)NULL;
 	}
 
-	// Setup the debugger frame
-	frmDebugger *debugger = new frmDebugger(form, wxString::Format(_("Debugger - %s"), obj->GetFullIdentifier().c_str()));
-
-	// Setup the connection properties to be used by the debugger
-	dbgConnProp cp;
-	cp.m_database = obj->GetDatabase()->GetIdentifier();
-	cp.m_host = obj->GetServer()->GetName();
-	cp.m_password = obj->GetDatabase()->GetServer()->GetPassword();
-	cp.m_port = NumToStr((long)obj->GetServer()->GetPort());
-	cp.m_sslMode = obj->GetServer()->GetSSL();
-	cp.m_userName = obj->GetServer()->GetUsername();
-
-	// Setup the debugging session
-	dlgDirectDbg *directDebugger = NULL;
-	directDebugger = debugger->addDirectDbg(cp);
-	if (directDebugger == NULL)
+	try
 	{
-		return 0;
+		new dbgController(form, obj, true);
 	}
-
-	dbgBreakPointList &breakpoints = directDebugger->getBreakpointList();
-	breakpoints.Append(new dbgBreakPoint(dbgBreakPoint::OID, NumToStr((long)obj->GetOid()), wxT("'NULL'")));
-	if (!directDebugger->startDebugging())
+	catch (const std::runtime_error &)
 	{
-		ctlTree *browser = form->GetBrowser();
-		wxTreeItemId item = browser->GetSelection();
-		if (obj == browser->GetObject(item))
-		{
-			pgCollection *coll = browser->GetParentCollection(obj->GetId());
-			browser->DeleteChildren(coll->GetId());
-			coll->ShowTreeDetail(browser);
-		}
-		return 0;
+		// just ignore this errors, we already logged them in native messages to
+		// the end-user
 	}
 
-	// Return the debugger window to frmMain.
-	if (debugger && !directDebugger->GetCancelled())
-		return debugger;
-	else
-		return 0;
+	return (wxWindow *)NULL;
 }
 
 bool debuggerFactory::CheckEnable(pgObject *obj)
@@ -130,23 +101,14 @@ bool debuggerFactory::CheckEnable(pgObject *obj)
 				if (obj->GetConnection()->GetIsEdb() && func->GetSource().Trim(false).StartsWith(wxT("$__EDBwrapped__$")))
 					return false;
 
-				if (func->GetReturnType() != wxT("trigger") && func->GetReturnType() != wxT("\"trigger\""))
+				if (func->GetReturnType() != wxT("trigger") &&
+				        func->GetReturnType() != wxT("\"trigger\""))
 				{
-					if (func->GetLanguage() == wxT("plpgsql") && obj->GetDatabase()->CanDebugPlpgsql())
+					if (func->GetLanguage() == wxT("plpgsql") &&
+					        obj->GetDatabase()->CanDebugPlpgsql())
 						return true;
-#ifndef EDB_LIBPQ
-#ifdef __WXMSW__
 					else if (func->GetLanguage() == wxT("edbspl") &&
-					         obj->GetConnection()->EdbMinimumVersion(8, 4) &&
-					         !obj->GetConnection()->EdbMinimumVersion(9, 0) &&
-					         !(PQiGetOutResult && PQiPrepareOut && PQiSendQueryPreparedOut))
-						return false;
-#else
-					else if (func->GetLanguage() == wxT("edbspl") && obj->GetConnection()->EdbMinimumVersion(8, 4))
-						return false;
-#endif
-#endif
-					else if (func->GetLanguage() == wxT("edbspl") && obj->GetDatabase()->CanDebugEdbspl())
+					         obj->GetDatabase()->CanDebugEdbspl())
 						return true;
 					else
 						return false;
@@ -194,16 +156,18 @@ wxWindow *breakpointFactory::StartDialog(frmMain *form, pgObject *obj)
 	// deep down in query threads.
 	// We also make sure the function name doesn't contain a : as that will
 	// sent the debugger API nuts.
-	pgSet *res = obj->GetConnection()->ExecuteSet(wxT("SELECT count(*) AS count, proname FROM pg_proc WHERE oid = ") + dbgOid + wxT(" GROUP BY proname"));
+	pgSet *res = obj->GetConnection()->ExecuteSet(
+	                 wxT("SELECT count(*) AS count, proname FROM pg_proc WHERE oid = ") + dbgOid + wxT(" GROUP BY proname"));
 	if (res->GetVal(wxT("proname")).Contains(wxT(":")))
 	{
 		wxLogError(_("Functions with a colon in the name cannot be debugged."));
-		return 0;
+		return (wxWindow *)NULL;
 	}
 
 	if (res->GetLong(wxT("count")) != 1)
 	{
 		wxLogError(_("The selected function could not be found."));
+
 		ctlTree *browser = form->GetBrowser();
 		wxTreeItemId item = browser->GetSelection();
 		if (obj == browser->GetObject(item))
@@ -212,36 +176,20 @@ wxWindow *breakpointFactory::StartDialog(frmMain *form, pgObject *obj)
 			browser->DeleteChildren(coll->GetId());
 			coll->ShowTreeDetail(browser);
 		}
-		return 0;
+		return (wxWindow *)NULL;
 	}
 
-	// Setup the debugger frame
-	frmDebugger *debugger = new frmDebugger(form, wxString::Format(_("Debugger - %s"), obj->GetFullIdentifier().c_str()));
-	debugger->Show(true);
-	debugger->Raise();
-
-	// Setup the connection properties to be used by the debugger
-	dbgConnProp cp;
-	cp.m_database = obj->GetDatabase()->GetIdentifier();
-	cp.m_host = obj->GetServer()->GetName();
-	cp.m_password = obj->GetDatabase()->GetServer()->GetPassword();
-	cp.m_port = NumToStr((long)obj->GetServer()->GetPort());
-	cp.m_sslMode = obj->GetServer()->GetSSL();
-	cp.m_userName = obj->GetServer()->GetUsername();
-
-	// Setup the debugging session
-	ctlCodeWindow *globalDebugger = NULL;
-	globalDebugger = debugger->addDebug(cp);
-	if (globalDebugger == NULL)
-		return 0;
-
-	dbgBreakPointList &breakpoints = globalDebugger->getBreakpointList();
-	breakpoints.Append(new dbgBreakPoint(dbgBreakPoint::OID, dbgOid, wxT("'NULL'")));
-
-	globalDebugger->startGlobalDebugging();
-
-	// Return the debugger window to frmMain.
-	return debugger;
+	try
+	{
+		new dbgController(form, obj, false);
+	}
+	catch (const std::runtime_error &)
+	{
+		// just ignore this errors, we already logged them in native messages to
+		// the end-user
+	}
+
+	return (wxWindow *)NULL;
 }
 
 bool breakpointFactory::CheckEnable(pgObject *obj)
@@ -266,23 +214,15 @@ bool breakpointFactory::CheckEnable(pgObject *obj)
 				pgFunction *func = (pgFunction *)obj;
 
 				// If this is an EDB wrapped function, no debugging allowed
-				if (obj->GetConnection()->GetIsEdb() && func->GetSource().Trim(false).StartsWith(wxT("$__EDBwrapped__$")))
+				if (obj->GetConnection()->GetIsEdb() &&
+				        func->GetSource().Trim(false).StartsWith(wxT("$__EDBwrapped__$")))
 					return false;
 
-				if (func->GetLanguage() == wxT("plpgsql") && obj->GetDatabase()->CanDebugPlpgsql())
+				if (func->GetLanguage() == wxT("plpgsql") &&
+				        obj->GetDatabase()->CanDebugPlpgsql())
 					return true;
-#ifndef EDB_LIBPQ
-#ifdef __WXMSW__
 				else if (func->GetLanguage() == wxT("edbspl") &&
-				         obj->GetConnection()->EdbMinimumVersion(8, 4) &&
-				         !(PQiGetOutResult && PQiPrepareOut && PQiSendQueryPreparedOut))
-					return false;
-#else
-				else if (func->GetLanguage() == wxT("edbspl") && obj->GetConnection()->EdbMinimumVersion(8, 4))
-					return false;
-#endif
-#endif
-				else if (func->GetLanguage() == wxT("edbspl") && obj->GetDatabase()->CanDebugEdbspl())
+				         obj->GetDatabase()->CanDebugEdbspl())
 					return true;
 				else
 					return false;
@@ -303,12 +243,15 @@ bool breakpointFactory::CheckEnable(pgObject *obj)
 				pgTrigger *trig = (pgTrigger *)obj;
 
 				// If this is an EDB wrapped function, no debugging allowed
-				if (obj->GetConnection()->GetIsEdb() && trig->GetSource().Trim(false).StartsWith(wxT("$__EDBwrapped__$")))
+				if (obj->GetConnection()->GetIsEdb() &&
+				        trig->GetSource().Trim(false).StartsWith(wxT("$__EDBwrapped__$")))
 					return false;
 
-				if (trig->GetLanguage() == wxT("plpgsql") && obj->GetDatabase()->CanDebugPlpgsql())
+				if (trig->GetLanguage() == wxT("plpgsql") &&
+				        obj->GetDatabase()->CanDebugPlpgsql())
 					return true;
-				else if (trig->GetLanguage() == wxT("edbspl") && obj->GetDatabase()->CanDebugEdbspl())
+				else if (trig->GetLanguage() == wxT("edbspl") &&
+				         obj->GetDatabase()->CanDebugEdbspl())
 					return true;
 				else
 					return false;
diff --git a/pgadmin/debugger/dlgDirectDbg.cpp b/pgadmin/debugger/dlgDirectDbg.cpp
index 2e1ef87..bb62988 100644
--- a/pgadmin/debugger/dlgDirectDbg.cpp
+++ b/pgadmin/debugger/dlgDirectDbg.cpp
@@ -16,38 +16,39 @@
 #include <wx/grid.h>
 
 // App headers
-#include "debugger/dlgDirectDbg.h"
-#include "debugger/frmDebugger.h"
-#include "debugger/dbgTargetInfo.h"
-#include "debugger/dbgPgConn.h"
-#include "debugger/ctlResultGrid.h"
-#include "debugger/dbgResultset.h"
+#include "ctl/ctlAuiNotebook.h"
+#include "db/pgConn.h"
+#include "db/pgQueryThread.h"
+#include "db/pgQueryResultEvent.h"
+#include "schema/pgObject.h"
 #include "debugger/dbgConst.h"
-#include "debugger/dbgDbResult.h"
-#include "debugger/ctlCodeWindow.h"
+#include "debugger/dbgBreakPoint.h"
+#include "debugger/dbgController.h"
+#include "debugger/dbgModel.h"
+#include "debugger/ctlStackWindow.h"
+#include "debugger/ctlMessageWindow.h"
+#include "debugger/ctlTabWindow.h"
+#include "debugger/frmDebugger.h"
+#include "debugger/dlgDirectDbg.h"
 
 #include "images/debugger.pngc"
 
-#include <stdexcept>
-
 #define lblMessage                  CTRL_STATIC("lblMessage")
 #define grdParams                   CTRL("grdParams", wxGrid)
 #define chkPkgInit                  CTRL_CHECKBOX("chkPkgInit")
+#define btnDebug                    CTRL_BUTTON("wxID_OK")
 
-IMPLEMENT_CLASS( dlgDirectDbg, pgDialog )
-
-BEGIN_EVENT_TABLE( dlgDirectDbg, pgDialog )
-	EVT_BUTTON( wxID_OK,                    dlgDirectDbg::OnOk )
-	EVT_BUTTON( wxID_CANCEL,                dlgDirectDbg::OnCancel )
-	EVT_BUTTON( MENU_ID_SPAWN_DEBUGGER,  dlgDirectDbg::OnDebug )
-	EVT_BUTTON( MENU_ID_NOTICE_RECEIVED, dlgDirectDbg::OnNoticeReceived )
-
-	EVT_MENU( RESULT_ID_DIRECT_TARGET_COMPLETE, dlgDirectDbg::OnTargetComplete )
-
-	EVT_CLOSE( dlgDirectDbg::OnClose )
+IMPLEMENT_CLASS(dlgDirectDbg, pgDialog)
 
+BEGIN_EVENT_TABLE(dlgDirectDbg, pgDialog)
+	EVT_BUTTON(wxID_OK,                               dlgDirectDbg::OnOk)
+	EVT_BUTTON(wxID_CANCEL,                           dlgDirectDbg::OnCancel)
+	EVT_GRID_CMD_LABEL_LEFT_CLICK(XRCID("grdParams"), dlgDirectDbg::OnClickGridLabel)
+	EVT_MENU(RESULT_ID_ARGS_UPDATED,                  dlgDirectDbg::ResultArgsUpdated)
+	EVT_MENU(RESULT_ID_ARGS_UPDATE_ERROR,             dlgDirectDbg::ResultArgsUpdateError)
 END_EVENT_TABLE()
 
+
 ////////////////////////////////////////////////////////////////////////////////
 // dlgDirectDbg constructor
 //
